'''
Created on 03.04.2011
@author: achim brand
'''

from tools import LittleToBig_4Bytes, LastUsed, ReasonableOffset
from sys import exit


def FileSizeFAT(NumFATSecs, SectorSize, fileSize, file):
    # find last used FAT entry and calculate file size regarding the FAAT
    if NumFATSecs <= 109:
        offsetLastDiFATEntry = 76 + (109 * 4) - 4
        valueLastUsedDiFATEntry, offsetLastUsedDiFATEntry, \
        freeEntries = LastUsed(offsetLastDiFATEntry, file)
        numberUsedDiFATEntries = 109 - freeEntries       
        offsetLastFATEntry = (valueLastUsedDiFATEntry + 2 )  * SectorSize - 4
        valueLastUsedFATEntry, offsetLastUsedFATEntry, \
        freeEntries = LastUsed(offsetLastFATEntry, file)
        numberUsedFATEntries = (NumFATSecs * SectorSize / 4) - freeEntries
        valueLastUsedDxFATEntry = valueLastUsedDiFATEntry
    else:
        file.seek(68,0); DIFATSect1 = int(LittleToBig_4Bytes(file.read(4)),16)
        if (ReasonableOffset(DIFATSect1, SectorSize, fileSize, 'DIFATSect1') == 0):
            exit(0)
        file.seek(72,0); NumDIFSecs = int(LittleToBig_4Bytes(file.read(4)),16)
            
        offsetLastDIFATSectorEntry = (DIFATSect1 + 2) * SectorSize - 4
        file.seek(offsetLastDIFATSectorEntry,0)
        valueLastDIFATSectorEntry = int(LittleToBig_4Bytes(file.read(4)),16)
        
        for i in range(NumDIFSecs - 2):
            offsetLastDIFATSectorEntry = (valueLastDIFATSectorEntry + 2) * SectorSize - 4
            file.seek(offsetLastDIFATSectorEntry,0)
            valueLastDIFATSectorEntry = int(LittleToBig_4Bytes(file.read(4)),16)

        offsetLastDIFATEntry = (valueLastDIFATSectorEntry + 2) * SectorSize - 8
        valueLastUsedDIFATEntry, offsetLastUsedDIFATEntry, \
        freeEntries = LastUsed(offsetLastDIFATEntry)
        numberUsedDIFATEntries = NumDIFSecs * ((SectorSize / 4) - 1) - freeEntries
        valueLastUsedDxFATEntry = valueLastUsedDIFATEntry
    
    offsetLastFATEntry = (valueLastUsedDxFATEntry + 2) * SectorSize - 4
    valueLastUsedFATEntry, offsetLastUsedFATEntry, \
    freeEntries = LastUsed(offsetLastFATEntry, file)
    numberUsedFATEntries = NumFATSecs * SectorSize / 4 - freeEntries 

    fileSizeFAT = (numberUsedFATEntries + 1) * SectorSize
    print 'File Size regarding FAT: \t%s\t\t\t (bytes)' % fileSizeFAT
    
    if fileSize > fileSizeFAT:
        print '############################################################'
        print '# Caution: File size sanity check failed.                  #'
        print '# Actual file size is larger than file size regarding FAT. #'
        print '# Something could be hidden within the file.               #'
        print '############################################################'
           
    pass
