'''
Created on 03.04.2011
@author: achim brand
'''

from TypedPropertyValuePacket import TypedPropertyValuePacket
from tools import LittleToBig_4Bytes


'''
http://msdn.microsoft.com/en-us/library/dd925819%28office.12%29.aspx
http://msdn.microsoft.com/en-us/library/dd942532.aspx
'''
PropertyIdToName = [
                    'NULL',             
                    'CodePage',             # 0x00000001      
                    'Title',                # 0x00000002
                    'Subject',              # 0x00000003
                    'Author',               # 0x00000004
                    'Keywords',             # 0x00000005
                    'Comments',             # 0x00000006
                    'Template',             # 0x00000007
                    'Last Author',          # 0x00000008
                    'Revision Number',      # 0x00000009
                    'Editing Time',         # 0x0000000A
                    'Last Printed Date',    # 0x0000000B
                    'Creation Date',        # 0x0000000C
                    'Last Save Date',       # 0x0000000D  
                    'Page Count',           # 0x0000000E
                    'Word Count',           # 0x0000000F
                    'Character Count',      # 0x00000010
                    'Thumbnail',            # 0x00000011 
                    'Application Name',     # 0x00000012
                    'Document Security',    # 0x00000013
                    ]
PropertyIdToName.append('NULL')


class PropertyIdentifierAndOffset(object):
    def __init__(self, propertyIdOffset, propertySetOffset, file):
        self.name = ''
        self.id = 0
        self.propertySetOffset = propertySetOffset
        self.propertyIdOffset = propertyIdOffset # offset to property identifier
        self.file = file
        self.offset = 0 # offset to TypedPropertyValue packets
        self.typedPropertyValuePacket = 0
        pass
                            
    def read(self):
        self.__readId()
        self.__readName()
        self.__readOffset()
        self.__readTPVP()
        pass
    
    def __readId(self):
        self.file.seek(self.propertyIdOffset,0)
        self.id = int(LittleToBig_4Bytes(self.file.read(4)),16)
        pass
    
    def __readName(self):
        self.name = PropertyIdToName[self.id]
        pass
    
    def __readOffset(self):
        self.file.seek(self.propertyIdOffset + 4,0)
        self.offset = int(LittleToBig_4Bytes(self.file.read(4)),16) + \
        self.propertySetOffset
        pass
    
    def __readTPVP(self):
        self.typedPropertyValuePacket = TypedPropertyValuePacket(self.id, self.offset, \
                                                                 self.file)
        self.typedPropertyValuePacket.read()
        pass
        
    # print PropertyIdentifierAndOffset
    def printPIAO(self):
        print 'Name: \t\t\t', self.name
        #print 'ID: ', self.id
        #print 'ID Offset: ', self.propertyIdOffset
        # http://msdn.microsoft.com/en-us/library/dd942532%28v=PROT.13%29.aspx
        self.typedPropertyValuePacket.printTPVP()
        print 'Offset to TPV packet: \t', self.offset
        print '----------------------------------------------------'
        pass      