'''
Created on 03.04.2011
@author: achim brand
'''

from PropertyIdentifierAndOffset import PropertyIdentifierAndOffset  
from tools import LittleToBig_4Bytes


class SummaryInformationPropertySet(object):
    def __init__(self, propertySetOffset, file):
        self.size = 0
        self.numproperties = 0
        self.propertySetOffset = propertySetOffset
        self.file = file
        self.propertyIdentifierAndOffsetArray = []
        self.read()
         
        for i in range(self.numproperties):
            # +8 because of Size (4 bytes) and NumProperties (4 bytes)
            self.propertyIdentifierAndOffsetArray.append\
            (PropertyIdentifierAndOffset(propertySetOffset + 8 + (i*8),\
                                          propertySetOffset, file))
        
        for obj in self.propertyIdentifierAndOffsetArray:
            obj.read();
            
        pass
            
    def read(self):
        self.__readSize()
        self.__readNumproperties()
        pass
    
    def __readSize(self):
        self.file.seek(self.propertySetOffset,0)
        self.size = int(LittleToBig_4Bytes(self.file.read(4)),16)     
        pass  
    
    def __readNumproperties(self):
        self.file.seek(self.propertySetOffset + 4,0)
        self.numproperties = int(LittleToBig_4Bytes(self.file.read(4)),16)
        pass
    
   
    # print SummaryInformation Property Set
    # http://msdn.microsoft.com/en-us/library/dd942089%28v=PROT.13%29.aspx        
    def printSIPS(self):
        print '----------------------------------------------------'
        print 'Summary Information Property Set Metadata:'
        print 'SIPS Size: %s (bytes)' % self.size
        print 'Number of Properties: ', self.numproperties
        print '----------------------------------------------------'
        for obj in self.propertyIdentifierAndOffsetArray:
            obj.printPIAO()
        print 'End of Summary Information Property Set Metadata.'
        print '----------------------------------------------------'
        pass    