'''
Created on 03.04.2011
@author: achim brand
'''

from globals import PIDSICODEPAGE, PIDSIEDITTIME, PIDSILASTSAVEDTM, PIDSIPAGECOUNT, PIDSICHRCOUNT, PIDSIDOCSECURITY, PIDSIREVNUMBER
from tools import LittleToBig_2Bytes, LittleToBig_4Bytes, LittleToBig_8Bytes, FiletimeToDatetime


class TypedPropertyValuePacket(object):
    def __init__(self, propertyIdentifier, packetOffset, file):
        self.propertyIdentifier = propertyIdentifier
        self.packetOffset = packetOffset
        self.file = file
        self.type = 0
        self.padding = 0
        self.size = 0
        self.characters = ''
        pass
        
    def read(self):
        self.__readType()
        self.__readPadding()
        if self.propertyIdentifier == PIDSICODEPAGE:
            self.__readCodepage()
        elif self.propertyIdentifier >= PIDSIEDITTIME and self.propertyIdentifier <= PIDSILASTSAVEDTM:
            self.__readDate()
        elif (self.propertyIdentifier >= PIDSIPAGECOUNT and self.propertyIdentifier <= PIDSICHRCOUNT) or (self.propertyIdentifier == PIDSIDOCSECURITY):
            self.__readNumber()
        else:
            self.__readSize()
            self.__readCharacters()
        pass
      
    def __readType(self):
        self.file.seek(self.packetOffset,0)
        self.type = LittleToBig_2Bytes(self.file.read(2))
        pass     
    
    def __readPadding(self):
        self.file.seek(self.packetOffset + 2,0)
        self.padding = int(LittleToBig_2Bytes(self.file.read(2)),16)
        pass
    
    def __readSize(self):
        self.file.seek(self.packetOffset + 4,0)
        self.size = int(LittleToBig_4Bytes(self.file.read(4)),16)
        pass
    
    def __readCharacters(self):
        if self.size != 0:
            self.file.seek(self.packetOffset + 8,0)
            self.characters = self.file.read(self.size)
        pass
    
    def __readCodepage(self):
        self.file.seek(self.packetOffset + 4,0)
        self.characters = LittleToBig_4Bytes(self.file.read(4))
        pass
        
    def __readDate(self):
        self.file.seek(self.packetOffset + 4,0)
        self.characters = FiletimeToDatetime(LittleToBig_8Bytes(self.file.read(8)))
        self.characters = self.characters
        pass
        
    def __readNumber(self):
        self.file.seek(self.packetOffset + 4,0)
        self.characters = int(LittleToBig_4Bytes(self.file.read(4)),16)
        pass     
        
        
    # print TypedPropertyValuePacket
    def printTPVP(self):
        #print 'TPVP Offset: ', self.packetOffset
        #print 'Type: ', self.type
        #print 'Padding: ', self.padding
        #print 'Size: ', self.size
        if (self.propertyIdentifier >= PIDSIEDITTIME and \
            self.propertyIdentifier <= PIDSILASTSAVEDTM):
            print 'Value: \t\t\t', self.characters, '(UTC)'
        elif (self.propertyIdentifier >= PIDSIPAGECOUNT and self.propertyIdentifier \
              <= PIDSICHRCOUNT) or (self.propertyIdentifier == PIDSIDOCSECURITY):
            print 'Value: \t\t\t', self.characters
        elif self.propertyIdentifier == PIDSIREVNUMBER:
            print 'Value: \t\t\t', self.characters.rstrip('\x00'), \
            '(regarding to CodePage)'
        else:
            print 'Value: \t\t\t', self.characters.rstrip('\x00')
        pass